<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: DayzExpansion/Core/Scripts/5_mission/dayzexpansion_core/classes/modules/datacollection/expansiondatacollectionmodule.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.12</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('df/d3f/expansiondatacollectionmodule_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">expansiondatacollectionmodule.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../df/d3f/expansiondatacollectionmodule_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * ExpansionDataCollectionModule.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * DayZ Expansion Mod</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * www.dayzexpansion.com</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * © 2022 DayZ Expansion Mod Team</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License. </span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-nd/4.0/.</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment">*/</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span><span class="comment"></span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno">   13</span><span class="comment">/**@class       ExpansionDataCollectionModule</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span><span class="comment"> * @brief       This class handles the data collection system</span></div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span><span class="comment"> **/</span><span class="comment"></span></div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span><span class="comment">//! TODO: Get rid of RPCs and use SyncPlayerList on client</span></div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno">   17</span><span class="comment"></span>[<a class="code hl_function" href="../../d1/d06/expansionworldobjectsmodule_8c.html#a65dbab13853969b0c9a6c127dfecfaea">CF_RegisterModule</a>(<a class="code hl_class" href="../../d7/dfa/class_expansion_data_collection_module.html">ExpansionDataCollectionModule</a>)]</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html">   18</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d7/dfa/class_expansion_data_collection_module.html">ExpansionDataCollectionModule</a>: CF_ModuleWorld</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span>{</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">   20</a></span>    <span class="keyword">private</span> autoptr map &lt;string, ref ExpansionPlayerDataCollection&gt; <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a58500aa61a81aa7b722b0cfd9fba440b">   21</a></span>    <span class="keyword">static</span> ref ScriptInvoker <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a58500aa61a81aa7b722b0cfd9fba440b">m_ModuleSI</a> = <span class="keyword">new</span> ScriptInvoker();</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>    </div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a889750ec9c20769a6c5f08222bccb892">   23</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a889750ec9c20769a6c5f08222bccb892">ExpansionDataCollectionModule</a>()</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>    {       </div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>        <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a> = <span class="keyword">new</span> map &lt;string, ref ExpansionPlayerDataCollection&gt;;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>    }</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>    </div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#affc2ef46a7f960040bd1ffd655c8d9c5">   28</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#affc2ef46a7f960040bd1ffd655c8d9c5">OnInit</a>()</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>    {</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>        super.OnInit();</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span> </div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>        EnableClientDisconnect();</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span>        EnableInvokeConnect();</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>        EnableRPC();</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>    }</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span> </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#aa00d43f4a2ae553dd05a38370dc77444">   39</a></span>    <span class="keyword">override</span> <span class="keywordtype">int</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#aa00d43f4a2ae553dd05a38370dc77444">GetRPCMin</a>()</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>    {</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span>        <span class="keywordflow">return</span> <a class="code hl_enumeration" href="../../d7/dfd/expansionrpc_8c.html#ac1dde2749f2cf716ca7bec9b1284bf57">ExpansionDataCollectionRPC</a>.INVALID;</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span>    }</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span> </div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a999d721c347ae6a5cd59988858d84e1c">   44</a></span>    <span class="keyword">override</span> <span class="keywordtype">int</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a999d721c347ae6a5cd59988858d84e1c">GetRPCMax</a>()</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>    {</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>        <span class="keywordflow">return</span> <a class="code hl_enumeration" href="../../d7/dfd/expansionrpc_8c.html#ac1dde2749f2cf716ca7bec9b1284bf57">ExpansionDataCollectionRPC</a>.COUNT;</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>    }</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>    </div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a2ddebbd8178e87fb479ba525f709d6f0">   49</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a2ddebbd8178e87fb479ba525f709d6f0">OnRPC</a>(Class sender, CF_EventArgs args)</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span>    {</div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span> </div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        super.OnRPC(sender, args);</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span> </div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span>        <span class="keyword">auto</span> rpc = CF_EventRPCArgs.Cast(args);</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>        <span class="keywordflow">switch</span> ( rpc.ID )</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>        {</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>        <span class="keywordflow">case</span> <a class="code hl_enumeration" href="../../d7/dfd/expansionrpc_8c.html#ac1dde2749f2cf716ca7bec9b1284bf57">ExpansionDataCollectionRPC</a>.RequestPlayerData:</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span>            <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#ad448fe80888479e9fdf478055f575ac2">RPC_RequestPlayerData</a>(rpc.Context, rpc.Sender);</div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>        <span class="keywordflow">case</span> <a class="code hl_enumeration" href="../../d7/dfd/expansionrpc_8c.html#ac1dde2749f2cf716ca7bec9b1284bf57">ExpansionDataCollectionRPC</a>.SendPlayerData:</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>            <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a080a1366d949f9e0ac5fd71206cb7f41">RPC_SendPlayerData</a>(rpc.Context);</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>            <span class="keywordflow">break</span>;</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span>        }</div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno">   66</span>    }</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>        </div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#aaf5821920af553436ae4fa26562156d6">   68</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#aaf5821920af553436ae4fa26562156d6">OnInvokeConnect</a>(Class sender, CF_EventArgs args)</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    {</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno">   71</span> </div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>        super.OnInvokeConnect(sender, args);</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>        </div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span>        <span class="keyword">auto</span> cArgs = CF_EventPlayerArgs.Cast(args);</div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span> </div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>        <span class="keywordflow">if</span> (!cArgs.Player)</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        </div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span>        <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#adee9b1feba197f244e44c7d4555fc830">OnPlayerConnect</a>(cArgs.Player);</div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>    }</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>    </div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#adee9b1feba197f244e44c7d4555fc830">   82</a></span>    <span class="keyword">private</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#adee9b1feba197f244e44c7d4555fc830">OnPlayerConnect</a>(<a class="code hl_function" href="../../d4/dc0/playerbase_8c.html#aae9be6814641164b753f18f7cf37075d">PlayerBase</a> player)</div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno">   83</span>    {       </div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span> </div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span>        <span class="keywordflow">if</span> (!IsMissionHost())</div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span>        </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        <span class="keywordtype">string</span> playerUID = player.GetIdentity().GetId();</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>        <a class="code hl_class" href="../../d7/da2/class_expansion_player_data_collection.html">ExpansionPlayerDataCollection</a> playerData;</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span>        <span class="keywordflow">if</span> (!<a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>.Find(playerUID, playerData))</div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno">   92</span>        {</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>            playerData = <span class="keyword">new</span> <a class="code hl_class" href="../../d7/da2/class_expansion_player_data_collection.html">ExpansionPlayerDataCollection</a>();</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>            <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>.Insert(playerUID, playerData);</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span>        }</div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span> </div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>        playerData.<a class="code hl_function" href="../../d7/da2/class_expansion_player_data_collection.html#a4b2e67d6bc7ed9b5de835f00e1b333bc">SetFromPlayerBase</a>(player);</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>    }</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>    </div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a3f268db855cc2e3352a482e2bd383f3f">  100</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a3f268db855cc2e3352a482e2bd383f3f">OnClientDisconnect</a>(Class sender, CF_EventArgs args)</div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>    {</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span> </div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>        super.OnClientDisconnect(sender, args);</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span> </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno">  106</span>        <span class="keyword">auto</span> cArgs = CF_EventPlayerDisconnectedArgs.Cast(args);</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span> </div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        <span class="keywordflow">if</span> (!cArgs.Identity)</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>        </div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span>        <span class="keywordtype">string</span> playerID = cArgs.Identity.GetId();</div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a0c3f91604a1985ada929c8a77a1b678e">OnPlayerDisconnect</a>(cArgs.UID);</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>    }</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span>    </div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a0c3f91604a1985ada929c8a77a1b678e">  115</a></span>    <span class="keyword">private</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a0c3f91604a1985ada929c8a77a1b678e">OnPlayerDisconnect</a>(<span class="keywordtype">string</span> playerUID)</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>    {       </div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span> </div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>        <span class="keywordflow">if</span> (!IsMissionHost())</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>        </div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>        <span class="keywordflow">if</span> (<a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>.Contains(playerUID))</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>        {</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>            <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>.Remove(playerUID);</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>        }</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>    }</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>    <span class="comment"></span></div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span><span class="comment">    //! Client</span></div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a270bc553360cecb64541535810e9b174">  129</a></span><span class="comment"></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a270bc553360cecb64541535810e9b174">RequestPlayerData</a>()</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span>    {       </div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span> </div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>        <span class="keywordflow">if</span> (!IsMissionClient())</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span>        </div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno">  136</span>        ScriptRPC rpc = <span class="keyword">new</span> ScriptRPC();</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>        rpc.Send(NULL, <a class="code hl_enumeration" href="../../d7/dfd/expansionrpc_8c.html#ac1dde2749f2cf716ca7bec9b1284bf57">ExpansionDataCollectionRPC</a>.RequestPlayerData, <span class="keyword">false</span>);</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>    }</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>    <span class="comment"></span></div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span><span class="comment">    //! Server</span></div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#ad448fe80888479e9fdf478055f575ac2">  141</a></span><span class="comment"></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#ad448fe80888479e9fdf478055f575ac2">RPC_RequestPlayerData</a>(ParamsReadContext ctx, PlayerIdentity sender)</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>    {       </div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span> </div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>        <span class="keywordflow">if</span> (!IsMissionHost())</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>        </div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>        ScriptRPC rpc = <span class="keyword">new</span> ScriptRPC();        </div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span>        <span class="keywordtype">int</span> playersClount = <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>.Count();</div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno">  150</span>        rpc.Write(playersClount);</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>    </div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>        <span class="keywordflow">foreach</span> (<span class="keyword">auto</span> playerData: <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>)</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span>        {</div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>            <span class="keywordflow">if</span> (!playerData)</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>                <span class="keywordflow">continue</span>;</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>            </div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>            playerData.OnSend(rpc);</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span>        }</div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno">  159</span>        </div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>        rpc.Send(NULL, <a class="code hl_enumeration" href="../../d7/dfd/expansionrpc_8c.html#ac1dde2749f2cf716ca7bec9b1284bf57">ExpansionDataCollectionRPC</a>.SendPlayerData, <span class="keyword">false</span>, sender);</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>    }</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>    <span class="comment"></span></div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span><span class="comment">    //! Client</span></div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a080a1366d949f9e0ac5fd71206cb7f41">  164</a></span><span class="comment"></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a080a1366d949f9e0ac5fd71206cb7f41">RPC_SendPlayerData</a>(ParamsReadContext ctx)</div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>    {</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span> </div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno">  168</span>        <span class="keywordflow">if</span> (!IsMissionClient())</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>        </div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>        <span class="keywordtype">int</span> playersCount;</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span>        <span class="keywordflow">if</span> (!ctx.Read(playersCount))</div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno">  173</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span> </div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>        <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>.Clear();</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>        </div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span>        <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i &lt; playersCount; i++)</div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>        {</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>            <span class="keywordflow">if</span> (!<a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a17db3c8ecb7eecd8d4d9f4154c4baeeb">OnReceivePlayerData</a>(ctx))</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span>                <span class="keywordflow">continue</span>;</div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno">  181</span>        }</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>        </div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>        <span class="keywordflow">if</span> (!<a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a58500aa61a81aa7b722b0cfd9fba440b">m_ModuleSI</a>)</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>            <span class="keywordflow">return</span>;</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span>        </div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno">  186</span>        <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a58500aa61a81aa7b722b0cfd9fba440b">m_ModuleSI</a>.Invoke();</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>    }</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>    </div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a17db3c8ecb7eecd8d4d9f4154c4baeeb">  189</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a17db3c8ecb7eecd8d4d9f4154c4baeeb">OnReceivePlayerData</a>(ParamsReadContext ctx)</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span>    {       </div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span> </div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span>        <span class="keywordtype">string</span> playerUID;</div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno">  194</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/d36/expansionstatic_8c.html#ae52b22a15cd70143ec56e9e0d067d950">Expansion_Assert_False</a>(ctx.Read(playerUID), <span class="stringliteral">&quot;Failed to read player UID&quot;</span>))</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span> </div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>        <a class="code hl_class" href="../../d7/da2/class_expansion_player_data_collection.html">ExpansionPlayerDataCollection</a> playerData;</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span>        <span class="keywordflow">if</span> (!<a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>.Find(playerUID, playerData))</div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno">  199</span>        {</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>            playerData = <span class="keyword">new</span> <a class="code hl_class" href="../../d7/da2/class_expansion_player_data_collection.html">ExpansionPlayerDataCollection</a>();</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>            playerData.<a class="code hl_variable" href="../../d7/da2/class_expansion_player_data_collection.html#a62379c43b93300c18423c4ad44241905">PlayerUID</a> = playerUID;</div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>            <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>.Insert(playerUID, playerData);</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span>        }</div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno">  204</span> </div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>        <span class="keywordflow">if</span> (<a class="code hl_function" href="../../d2/d36/expansionstatic_8c.html#ae52b22a15cd70143ec56e9e0d067d950">Expansion_Assert_False</a>(playerData.<a class="code hl_function" href="../../d7/da2/class_expansion_player_data_collection.html#ade0da8c7bac9febada30eaad9da5592a">OnRecieve</a>(ctx), <span class="stringliteral">&quot;Failed to read player data&quot;</span>))</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>        </div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno">  209</span>    }</div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>    </div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno"><a class="line" href="../../d7/dfa/class_expansion_data_collection_module.html#a95c84975b5eaf0e2a0475893f0b9dfc7">  211</a></span>    map &lt;string, ref ExpansionPlayerDataCollection&gt; <a class="code hl_function" href="../../d7/dfa/class_expansion_data_collection_module.html#a95c84975b5eaf0e2a0475893f0b9dfc7">GetAllPlayers</a>()</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>    {</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">m_PlayerData</a>;</div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>    }</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>};</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span> </div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno"><a class="line" href="../../de/db0/class_expansion_data_collection.html">  217</a></span><span class="keyword">class </span><a class="code hl_class" href="../../de/db0/class_expansion_data_collection.html">ExpansionDataCollection</a></div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>{</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno"><a class="line" href="../../de/db0/class_expansion_data_collection.html#a3d8b5aa66095d95b3e8698fc757a098b">  219</a></span>    <span class="keywordtype">bool</span> <a class="code hl_function" href="../../de/db0/class_expansion_data_collection.html#a3d8b5aa66095d95b3e8698fc757a098b">OnRecieve</a>(ParamsReadContext ctx);</div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno"><a class="line" href="../../de/db0/class_expansion_data_collection.html#a9809fc761441f9f7ea0654709eb9f7cc">  220</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../de/db0/class_expansion_data_collection.html#a9809fc761441f9f7ea0654709eb9f7cc">OnSend</a>(ParamsWriteContext ctx);</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>};</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span> </div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno"><a class="line" href="../../d7/da2/class_expansion_player_data_collection.html">  223</a></span><span class="keyword">class </span><a class="code hl_class" href="../../d7/da2/class_expansion_player_data_collection.html">ExpansionPlayerDataCollection</a>: <a class="code hl_class" href="../../de/db0/class_expansion_data_collection.html">ExpansionDataCollection</a></div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>{</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno"><a class="line" href="../../d7/da2/class_expansion_player_data_collection.html#a62379c43b93300c18423c4ad44241905">  225</a></span>    <span class="keywordtype">string</span> <a class="code hl_variable" href="../../d7/da2/class_expansion_player_data_collection.html#a62379c43b93300c18423c4ad44241905">PlayerUID</a>;</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno"><a class="line" href="../../d7/da2/class_expansion_player_data_collection.html#a1a0a2e0650f56abfb5e96eeb944bfc8e">  226</a></span>    <span class="keywordtype">string</span> <a class="code hl_variable" href="../../d7/da2/class_expansion_player_data_collection.html#a1a0a2e0650f56abfb5e96eeb944bfc8e">Name</a>;</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span>    </div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno"><a class="line" href="../../d7/da2/class_expansion_player_data_collection.html#a4b2e67d6bc7ed9b5de835f00e1b333bc">  228</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/da2/class_expansion_player_data_collection.html#a4b2e67d6bc7ed9b5de835f00e1b333bc">SetFromPlayerBase</a>(<a class="code hl_function" href="../../d4/dc0/playerbase_8c.html#aae9be6814641164b753f18f7cf37075d">PlayerBase</a> player)</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>    {</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno">  231</span> </div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>        <a class="code hl_variable" href="../../d7/da2/class_expansion_player_data_collection.html#a62379c43b93300c18423c4ad44241905">PlayerUID</a> = player.GetIdentity().GetId();</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>        <a class="code hl_variable" href="../../d7/da2/class_expansion_player_data_collection.html#a1a0a2e0650f56abfb5e96eeb944bfc8e">Name</a> = player.GetIdentity().GetName();</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span>    }</div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>    </div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno"><a class="line" href="../../d7/da2/class_expansion_player_data_collection.html#a207bdf5dd352d0c3c7336c94038b48b3">  236</a></span>    <span class="keyword">override</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../d7/da2/class_expansion_player_data_collection.html#a207bdf5dd352d0c3c7336c94038b48b3">OnSend</a>(ParamsWriteContext ctx)</div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>    {</div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span> </div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span>        ctx.Write(<a class="code hl_variable" href="../../d7/da2/class_expansion_player_data_collection.html#a62379c43b93300c18423c4ad44241905">PlayerUID</a>);</div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>        ctx.Write(<a class="code hl_variable" href="../../d7/da2/class_expansion_player_data_collection.html#a1a0a2e0650f56abfb5e96eeb944bfc8e">Name</a>);</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>    }</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span>    </div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno"><a class="line" href="../../d7/da2/class_expansion_player_data_collection.html#ade0da8c7bac9febada30eaad9da5592a">  244</a></span>    <span class="keyword">override</span> <span class="keywordtype">bool</span> <a class="code hl_function" href="../../d7/da2/class_expansion_player_data_collection.html#ade0da8c7bac9febada30eaad9da5592a">OnRecieve</a>(ParamsReadContext ctx)</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>    {</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>        <span class="keyword">auto</span> trace = <a class="code hl_class" href="../../d6/ddc/class_e_x_trace.html">EXTrace</a>.<a class="code hl_function" href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">Start</a>(ExpansionTracing.DATACOLLECTION);</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span> </div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>        <span class="keywordflow">if</span> (!ctx.Read(<a class="code hl_variable" href="../../d7/da2/class_expansion_player_data_collection.html#a1a0a2e0650f56abfb5e96eeb944bfc8e">Name</a>))</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span>            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>        </div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span>        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span>    }</div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno">  253</span>};</div>
<div class="ttc" id="aclass_e_x_trace_html"><div class="ttname"><a href="../../d6/ddc/class_e_x_trace.html">EXTrace</a></div><div class="ttdef"><b>Definition:</b> <a href="../../df/d4f/expansiontracing_8c_source.html#l00029">expansiontracing.c:30</a></div></div>
<div class="ttc" id="aclass_e_x_trace_html_ab7af4b282c08a043d2f9626231c59953"><div class="ttname"><a href="../../d6/ddc/class_e_x_trace.html#ab7af4b282c08a043d2f9626231c59953">EXTrace::Start</a></div><div class="ttdeci">static EXTrace Start(bool yes=true, Class instance=null, string param0=&quot;&quot;, string param1=&quot;&quot;, string param2=&quot;&quot;, string param3=&quot;&quot;, string param4=&quot;&quot;, string param5=&quot;&quot;, string param6=&quot;&quot;, string param7=&quot;&quot;, string param8=&quot;&quot;, string param9=&quot;&quot;)</div><div class="ttdoc">Includes 1st line of stack.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d4f/expansiontracing_8c_source.html#l00323">expansiontracing.c:323</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_html"><div class="ttname"><a href="../../de/db0/class_expansion_data_collection.html">ExpansionDataCollection</a></div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00217">expansiondatacollectionmodule.c:218</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_html_a3d8b5aa66095d95b3e8698fc757a098b"><div class="ttname"><a href="../../de/db0/class_expansion_data_collection.html#a3d8b5aa66095d95b3e8698fc757a098b">ExpansionDataCollection::OnRecieve</a></div><div class="ttdeci">bool OnRecieve(ParamsReadContext ctx)</div></div>
<div class="ttc" id="aclass_expansion_data_collection_html_a9809fc761441f9f7ea0654709eb9f7cc"><div class="ttname"><a href="../../de/db0/class_expansion_data_collection.html#a9809fc761441f9f7ea0654709eb9f7cc">ExpansionDataCollection::OnSend</a></div><div class="ttdeci">void OnSend(ParamsWriteContext ctx)</div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html">ExpansionDataCollectionModule</a></div><div class="ttdoc">TODO: Get rid of RPCs and use SyncPlayerList on client.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00018">expansiondatacollectionmodule.c:19</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a080a1366d949f9e0ac5fd71206cb7f41"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a080a1366d949f9e0ac5fd71206cb7f41">ExpansionDataCollectionModule::RPC_SendPlayerData</a></div><div class="ttdeci">void RPC_SendPlayerData(ParamsReadContext ctx)</div><div class="ttdoc">Client.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00164">expansiondatacollectionmodule.c:164</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a0c3f91604a1985ada929c8a77a1b678e"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a0c3f91604a1985ada929c8a77a1b678e">ExpansionDataCollectionModule::OnPlayerDisconnect</a></div><div class="ttdeci">private void OnPlayerDisconnect(string playerUID)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00115">expansiondatacollectionmodule.c:115</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a17db3c8ecb7eecd8d4d9f4154c4baeeb"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a17db3c8ecb7eecd8d4d9f4154c4baeeb">ExpansionDataCollectionModule::OnReceivePlayerData</a></div><div class="ttdeci">bool OnReceivePlayerData(ParamsReadContext ctx)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00189">expansiondatacollectionmodule.c:189</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a2424632007c5213fe92f58875977d48c"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a2424632007c5213fe92f58875977d48c">ExpansionDataCollectionModule::m_PlayerData</a></div><div class="ttdeci">private autoptr map&lt; string, ref ExpansionPlayerDataCollection &gt; m_PlayerData</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00020">expansiondatacollectionmodule.c:20</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a270bc553360cecb64541535810e9b174"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a270bc553360cecb64541535810e9b174">ExpansionDataCollectionModule::RequestPlayerData</a></div><div class="ttdeci">void RequestPlayerData()</div><div class="ttdoc">Client.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00129">expansiondatacollectionmodule.c:129</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a2ddebbd8178e87fb479ba525f709d6f0"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a2ddebbd8178e87fb479ba525f709d6f0">ExpansionDataCollectionModule::OnRPC</a></div><div class="ttdeci">override void OnRPC(Class sender, CF_EventArgs args)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00049">expansiondatacollectionmodule.c:49</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a3f268db855cc2e3352a482e2bd383f3f"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a3f268db855cc2e3352a482e2bd383f3f">ExpansionDataCollectionModule::OnClientDisconnect</a></div><div class="ttdeci">override void OnClientDisconnect(Class sender, CF_EventArgs args)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00100">expansiondatacollectionmodule.c:100</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a58500aa61a81aa7b722b0cfd9fba440b"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a58500aa61a81aa7b722b0cfd9fba440b">ExpansionDataCollectionModule::m_ModuleSI</a></div><div class="ttdeci">static ref ScriptInvoker m_ModuleSI</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00021">expansiondatacollectionmodule.c:21</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a889750ec9c20769a6c5f08222bccb892"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a889750ec9c20769a6c5f08222bccb892">ExpansionDataCollectionModule::ExpansionDataCollectionModule</a></div><div class="ttdeci">void ExpansionDataCollectionModule()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00023">expansiondatacollectionmodule.c:23</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a95c84975b5eaf0e2a0475893f0b9dfc7"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a95c84975b5eaf0e2a0475893f0b9dfc7">ExpansionDataCollectionModule::GetAllPlayers</a></div><div class="ttdeci">map&lt; string, ref ExpansionPlayerDataCollection &gt; GetAllPlayers()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00211">expansiondatacollectionmodule.c:211</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_a999d721c347ae6a5cd59988858d84e1c"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#a999d721c347ae6a5cd59988858d84e1c">ExpansionDataCollectionModule::GetRPCMax</a></div><div class="ttdeci">override int GetRPCMax()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00044">expansiondatacollectionmodule.c:44</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_aa00d43f4a2ae553dd05a38370dc77444"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#aa00d43f4a2ae553dd05a38370dc77444">ExpansionDataCollectionModule::GetRPCMin</a></div><div class="ttdeci">override int GetRPCMin()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00039">expansiondatacollectionmodule.c:39</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_aaf5821920af553436ae4fa26562156d6"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#aaf5821920af553436ae4fa26562156d6">ExpansionDataCollectionModule::OnInvokeConnect</a></div><div class="ttdeci">override void OnInvokeConnect(Class sender, CF_EventArgs args)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00068">expansiondatacollectionmodule.c:68</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_ad448fe80888479e9fdf478055f575ac2"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#ad448fe80888479e9fdf478055f575ac2">ExpansionDataCollectionModule::RPC_RequestPlayerData</a></div><div class="ttdeci">void RPC_RequestPlayerData(ParamsReadContext ctx, PlayerIdentity sender)</div><div class="ttdoc">Server.</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00141">expansiondatacollectionmodule.c:141</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_adee9b1feba197f244e44c7d4555fc830"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#adee9b1feba197f244e44c7d4555fc830">ExpansionDataCollectionModule::OnPlayerConnect</a></div><div class="ttdeci">private void OnPlayerConnect(PlayerBase player)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00082">expansiondatacollectionmodule.c:82</a></div></div>
<div class="ttc" id="aclass_expansion_data_collection_module_html_affc2ef46a7f960040bd1ffd655c8d9c5"><div class="ttname"><a href="../../d7/dfa/class_expansion_data_collection_module.html#affc2ef46a7f960040bd1ffd655c8d9c5">ExpansionDataCollectionModule::OnInit</a></div><div class="ttdeci">override void OnInit()</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00028">expansiondatacollectionmodule.c:28</a></div></div>
<div class="ttc" id="aclass_expansion_player_data_collection_html"><div class="ttname"><a href="../../d7/da2/class_expansion_player_data_collection.html">ExpansionPlayerDataCollection</a></div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00223">expansiondatacollectionmodule.c:224</a></div></div>
<div class="ttc" id="aclass_expansion_player_data_collection_html_a1a0a2e0650f56abfb5e96eeb944bfc8e"><div class="ttname"><a href="../../d7/da2/class_expansion_player_data_collection.html#a1a0a2e0650f56abfb5e96eeb944bfc8e">ExpansionPlayerDataCollection::Name</a></div><div class="ttdeci">string Name</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00226">expansiondatacollectionmodule.c:226</a></div></div>
<div class="ttc" id="aclass_expansion_player_data_collection_html_a207bdf5dd352d0c3c7336c94038b48b3"><div class="ttname"><a href="../../d7/da2/class_expansion_player_data_collection.html#a207bdf5dd352d0c3c7336c94038b48b3">ExpansionPlayerDataCollection::OnSend</a></div><div class="ttdeci">override void OnSend(ParamsWriteContext ctx)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00236">expansiondatacollectionmodule.c:236</a></div></div>
<div class="ttc" id="aclass_expansion_player_data_collection_html_a4b2e67d6bc7ed9b5de835f00e1b333bc"><div class="ttname"><a href="../../d7/da2/class_expansion_player_data_collection.html#a4b2e67d6bc7ed9b5de835f00e1b333bc">ExpansionPlayerDataCollection::SetFromPlayerBase</a></div><div class="ttdeci">void SetFromPlayerBase(PlayerBase player)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00228">expansiondatacollectionmodule.c:228</a></div></div>
<div class="ttc" id="aclass_expansion_player_data_collection_html_a62379c43b93300c18423c4ad44241905"><div class="ttname"><a href="../../d7/da2/class_expansion_player_data_collection.html#a62379c43b93300c18423c4ad44241905">ExpansionPlayerDataCollection::PlayerUID</a></div><div class="ttdeci">string PlayerUID</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00225">expansiondatacollectionmodule.c:225</a></div></div>
<div class="ttc" id="aclass_expansion_player_data_collection_html_ade0da8c7bac9febada30eaad9da5592a"><div class="ttname"><a href="../../d7/da2/class_expansion_player_data_collection.html#ade0da8c7bac9febada30eaad9da5592a">ExpansionPlayerDataCollection::OnRecieve</a></div><div class="ttdeci">override bool OnRecieve(ParamsReadContext ctx)</div><div class="ttdef"><b>Definition:</b> <a href="../../df/d3f/expansiondatacollectionmodule_8c_source.html#l00244">expansiondatacollectionmodule.c:244</a></div></div>
<div class="ttc" id="aexpansionrpc_8c_html_ac1dde2749f2cf716ca7bec9b1284bf57"><div class="ttname"><a href="../../d7/dfd/expansionrpc_8c.html#ac1dde2749f2cf716ca7bec9b1284bf57">ExpansionDataCollectionRPC</a></div><div class="ttdeci">ExpansionDataCollectionRPC</div><div class="ttdef"><b>Definition:</b> <a href="../../d7/dfd/expansionrpc_8c_source.html#l00142">expansionrpc.c:143</a></div></div>
<div class="ttc" id="aexpansionstatic_8c_html_ae52b22a15cd70143ec56e9e0d067d950"><div class="ttname"><a href="../../d2/d36/expansionstatic_8c.html#ae52b22a15cd70143ec56e9e0d067d950">Expansion_Assert_False</a></div><div class="ttdeci">static bool Expansion_Assert_False(bool check, string message)</div><div class="ttdef"><b>Definition:</b> <a href="../../d2/d36/expansionstatic_8c_source.html#l00013">expansionstatic.c:13</a></div></div>
<div class="ttc" id="aexpansionworldobjectsmodule_8c_html_a65dbab13853969b0c9a6c127dfecfaea"><div class="ttname"><a href="../../d1/d06/expansionworldobjectsmodule_8c.html#a65dbab13853969b0c9a6c127dfecfaea">CF_RegisterModule</a></div><div class="ttdeci">ExpansionRemovedObject OLinkT CF_RegisterModule(ExpansionWorldObjectsModule)</div><div class="ttdef"><b>Definition:</b> <a href="../../d1/d06/expansionworldobjectsmodule_8c_source.html#l00001">expansionworldobjectsmodule.c:25</a></div></div>
<div class="ttc" id="aplayerbase_8c_html_aae9be6814641164b753f18f7cf37075d"><div class="ttname"><a href="../../d4/dc0/playerbase_8c.html#aae9be6814641164b753f18f7cf37075d">PlayerBase</a></div><div class="ttdeci">void PlayerBase()</div><div class="ttdef"><b>Definition:</b> <a href="../../d4/dc0/playerbase_8c_source.html#l00040">playerbase.c:40</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_6127fff2da0a20e2dc2cd9302c584350.html">DayzExpansion</a></li><li class="navelem"><a class="el" href="../../dir_fa1f4f079ed95106cba6603012ba90d8.html">Core</a></li><li class="navelem"><a class="el" href="../../dir_4763e2204ca4935d3e08fff4ec8c41d9.html">Scripts</a></li><li class="navelem"><a class="el" href="../../dir_ee841cbe272fde7d7d8de5f31a96d644.html">5_mission</a></li><li class="navelem"><a class="el" href="../../dir_d9bf3955f906b79792cbbbe771cbfdb0.html">dayzexpansion_core</a></li><li class="navelem"><a class="el" href="../../dir_0d79a6a0549ca5f187c50ba519253c0f.html">classes</a></li><li class="navelem"><a class="el" href="../../dir_4302619828b0ff49dd10a52d1b5323a5.html">modules</a></li><li class="navelem"><a class="el" href="../../dir_3ecd613e3a07c412c052739629f180ae.html">datacollection</a></li><li class="navelem"><a class="el" href="../../df/d3f/expansiondatacollectionmodule_8c.html">expansiondatacollectionmodule.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
